libzypp: zypp::base Namespace Reference

libzypp 17.36.6

Namespaces | Classes | Typedefs | Functions
zypp::base Namespace Reference

## Namespaces
namespace | logger
namespace | sysconfig

## Classes
class | ContainerTransform
| Helper managing a container of raw values with transformed representation. More...
class | Flags
| A type-safe way of storing OR-combinations of enum values (like QTs QFlags). More...
class | LogControl
| Maintain logfile related options. More...
struct | LogControlImpl
| LogControl implementation (thread_local Singleton). More...
struct | ProfilingFormater
struct | ProvideNumericId
| Base class for objects providing a numeric Id. More...
class | ReferenceCounted
| Base class for reference counted objects. More...
class | SetRelationMixin
| Provide set relation methods based on Derived::setRelationMixinCompare A class using this mixin must provide: More...
class | SetTracker
| Track added/removed set items based on an initial set. More...
class | Unit
| Simple handling of Units. More...
class | ValueTransform
| Helper managing raw values with transformed representation. More...

## Typedefs
using | NonCopyable = boost::noncopyable
| Ensure derived classes cannot be copied.

## Functions
int | random_int ()
std::string | random_string (int length)
unsigned | random ()
| Return a random number from `[0,RAND_MAX[`.
unsigned | random (unsigned size_r)
| Return a random number from `[0,size_r[`.
unsigned | random (unsigned min_r, unsigned size_r)
| Return a random number from `[min_r,min_r+size_r[`.
template<typename TEnum>
std::ostream & | operator<< (std::ostream &str, const Flags< TEnum > &obj)
template<typename TEnum>
std::ostream & | operator<< (std::ostream &str, const typename Flags< TEnum >::Enum &obj)
std::ostream & | operator<< (std::ostream &str, const LogControl &obj)
template<class Derived>
SetCompare | compare (const SetRelationMixin< Derived > &src, const SetRelationMixin< Derived > &trg)
| Compare sets.
template<class Derived>
bool | compare (const SetRelationMixin< Derived > &src, const SetRelationMixin< Derived > &trg, SetCompare cmp)
| Compare sets and match against SetCompare.
template<class Derived>
bool | compare (const SetRelationMixin< Derived > &src, const SetRelationMixin< Derived > &trg, SetRelation rel)
| Compare sets and match against SetRelation.
template<class Derived>
bool | operator== (const SetRelationMixin< Derived > &src, const SetRelationMixin< Derived > &trg)
| Equal.
template<class Derived>
bool | operator!= (const SetRelationMixin< Derived > &src, const SetRelationMixin< Derived > &trg)
| Unequal.
template<class TSet>
std::ostream & | operator<< (std::ostream &str, const SetTracker< TSet > &obj)
| Stream output.
template<typename Enum>
std::string | stringify (const Flags< Enum > &flag_r, const std::initializer_list< std::pair< Flags< Enum >, std::string > > &flaglist_r={}, std::string intro_r="[", std::string sep_r="|", const std::string &extro_r="]")
| Stringify Build a string of OR'ed names of each flag value set in flag_r.
std::ostream & | operator<< (std::ostream &str, const LogControl &obj) ZYPP_API
| Stream output.
void | intrusive_ptr_add_ref (const ReferenceCounted *ptr_r)
| intrusive_ptr hook to add_ref.
void | intrusive_ptr_release (const ReferenceCounted *ptr_r)
| intrusive_ptr hook to release.
std::ostream & | operator<< (std::ostream &str, const ReferenceCounted &obj)
| Stream output.

## Typedef Documentation

## ◆ NonCopyable

using zypp::base::NonCopyable = boost::noncopyable

Ensure derived classes cannot be copied.

Use private inheritance.

Definition at line 26 of file NonCopyable.h.

## Function Documentation

## ◆ random_int()

int zypp::base::random_int | ( |  | ) |

Definition at line 10 of file Random.cc.

## ◆ random_string()

std::string zypp::base::random_string | ( | int | length | ) |

Definition at line 31 of file Random.cc.

## ◆ random() [1/3]

unsigned zypp::base::random | ( |  | ) |
| inline

Return a random number from `[0,RAND_MAX[`.

Definition at line 28 of file Random.h.

## ◆ random() [2/3]

unsigned zypp::base::random | ( | unsigned | size_r | ) |
| inline

Return a random number from `[0,size_r[`.

Definition at line 33 of file Random.h.

## ◆ random() [3/3]

unsigned zypp::base::random | ( | unsigned | min_r,
|  | unsigned | size_r )
| inline

Return a random number from `[min_r,min_r+size_r[`.

Definition at line 38 of file Random.h.

## ◆ operator<<() [1/6]

template<typename TEnum>

std::ostream & zypp::base::operator<< | ( | std::ostream & | str,
|  | const Flags< TEnum > & | obj )
| inline

Definition at line 166 of file Flags.h.

## ◆ operator<<() [2/6]

template<typename TEnum>

std::ostream & zypp::base::operator<< | ( | std::ostream & | str,
|  | const typename Flags< TEnum >::Enum & | obj )
| inline

Definition at line 170 of file Flags.h.

## ◆ operator<<() [3/6]

std::ostream & zypp::base::operator<< | ( | std::ostream & | str,
|  | const LogControl & | obj )
| related

Definition at line 966 of file LogControl.cc.